                    +-----------------------------------------------+
                    +      Como Poner En Funcionamiento ProSum      +
                    +          por fkt <fkt@funfatal.org>           +
                    +-----------------------------------------------+

- Indice:
  1. Bajando
  2. Configurando
  3. Compilando
  4. Poniendo En Marcha
  5. Ejecutando
  6. Automatizando
  7. Recomendaciones

                     -----------------------------------------------

1. Bajando:
   Para bajar el programa vamos a http://prosum.sourceforge.net y nos bajamos la ultima
   version que haya disponible.

2. Configurando:
   Una vez bajado, lo descomprimimos con tar xvfz prosum_<version>.tgz
   Luego entramos en el directorio prosum_<version>:
   $ cd prosum_<version>
   $

   Ahora haremos el configure, si hacemos un ./configure --help vemos que al final hay 
   unas cosas que son interesantes en caso de no tener las librerias en paths "standards"
   --enable and --with options recognized:
     --disable-nls           disable nls
     --with-msgfmt=PATH_TO_MSGFMT   use PATH_TO_MSGFMT program for build ProSum.mo
     --with-make=MAKE      use MAKE program for build
     --with-intl-headers=DIR      use libintl headers in DIR
     --with-termcap-headers=DIR      use libtermcap headers in DIR
     --with-readline-headers=DIR      use libreadline headers in DIR
     --with-intl=DIR      use libintl in DIR
     --with-termcap=DIR    use libtermcap in DIR
     --with-readline=DIR      use libreadline in DIR
     --disable-gpg-dynload       disable use of GPG extensions

   Esto es en caso de que el ./configure no detecte alguna de esas librerias se las puedas 
   especificar tu a mano, los --with-X=DIR es para especificar la ruta al .so, y los 
   --with-X-headers=DIR es para especificar la ruta a las cabeceras (.h).
   Entonces ahora hacemos el configure a ver si nos detecta todo:
   $ ./configure
   creating cache ./config.cache
   checking host system type... i686-pc-linux-gnu
   checking target system type... i686-pc-linux-gnu
   checking build system type... i686-pc-linux-gnu
   checking for gcc... gcc
   checking whether the C compiler (gcc  ) works... yes
   checking whether the C compiler (gcc  ) is a cross-compiler... no
   checking whether we are using GNU C... yes
   checking whether gcc accepts -g... yes
   checking how to run the C preprocessor... gcc -E
   checking whether byte ordering is bigendian... no
   checking for a BSD compatible install... /usr/bin/install -c
   checking whether use of i18n is requested... yes
   checking for msgfmt... yes
   checking for crypt in -lcrypt... yes
   checking for socket in -lsocket... no
   checking for gethostbyname in -lnsl... yes
   checking for tcsetattr in -ltermcap... yes
   checking for readline in -lreadline... yes
   checking whether struct stat has a st_flags field... no
   checking for ext2fs/ext2_fs.h... yes
   checking for dirent.h that defines DIR... yes
   checking for opendir in -ldir... no
   checking for ANSI C header files... yes
   checking for fcntl.h... yes
   checking for syslog.h... yes
   checking for unistd.h... yes
   checking for getopt.h... yes
   checking for limits.h... yes
   checking for working const... yes
   checking for mode_t... yes
   checking for off_t... yes
   checking for size_t... yes
   checking whether time.h and sys/time.h may both be included... yes
   checking whether struct tm is in sys/time.h or time.h... time.h
   checking for 8-bit clean memcmp... yes
   checking whether utime accepts a null argument... yes
   checking return type of signal handlers... void
   checking for strftime... yes
   checking for select... yes
   checking for socket... yes
   checking for strstr... yes
   checking for strtoul... yes
   checking for chflags... no
   You Want KSyms Protection Support? (Y/N) default: Y: y
   You Want Syscall Protection Support? (Y/N) default: Y: y
   You Want IDT Protection Support? (Y/N) default: Y: y
   (Como lo estamos compilando en un Linux x86 nos pregunta si queremos soporte para la
    proteccion de la IDT, KSyms y las syscalls, le decimos que si poniendo una y en todos)
   checking for ar... ar
   checking for ranlib... ranlib
   checking for langinfo.h... yes
   checking for termio.h... yes
   checking for rand... yes
   checking for getrusage... yes
   checking for gettimeofday... yes
   checking for strerror... yes
   checking for nl_langinfo... yes
   checking for raise... yes
   checking for atexit... yes
   checking for mmap... yes
   checking for getpagesize... yes
   checking for stpcpy... yes
   checking for strsep... yes
   checking for strlwr... no
   checking for strcasecmp... yes
   checking for memicmp... no
   checking for memmove... yes
   checking for mlock... yes
   checking whether mlock is broken... no
   checking for byte typedef... no
   checking for ushort typedef... yes
   checking for ulong typedef... yes
   checking for u16 typedef... no
   checking for u32 typedef... no
   checking for option to create PIC... -fPIC
   checking how to specify -export-dynamic... -Wl,-export-dynamic
   checking whether use of extensions is requested... yes
   checking for dlopen in -ldl... yes
   checking for BSD-compatible nm... /usr/bin/nm -B
   checking command to parse /usr/bin/nm -B output... no
   checking for _ prefix in compiled symbols... no
   checking size of unsigned long... 4
   checking for gethrtime... no
   Set ProSum Password (Max Length 30): PASSWORD
   (Ponemos el password que queramos y le damos a <enter>)
   updating cache ./config.cache
   creating ./config.status
   creating utils/snd_tcp_serv/Makefile
   creating Makefile
   creating include/Makefile
   creating locale/es/LC_MESSAGES/Makefile
   creating gpg/Makefile
   creating gpg/util/Makefile
   creating gpg/cipher/Makefile
   creating utils/Makefile
   creating config.h
   $

   Nos ha detectado todo, en caso de que no detectara alguna libreria o alguna funcion que 
   sea necesaria daria error aqui o mas tarde al compilar. En los sistemas donde gettext use
   la libintl.so hay que especificaselo al configure con --with-intl=/ruta/a/libintl.so
   Si no quieres soporte para i18n haz el configure con --disable-nls
   Despues de hacer el configure editaremos el include/config_prosum.h por si queremos 
   cambiar algo, el contenido de config_prosum.h es el siguiente:
   #ifndef _CONFIG_PROSUM_H
   #define _CONFIG_PROSUM_H

   #include "../config.h"

   #ifdef KSYMS_SUPPORT
     /* Numero maximo de KSyms a proteger */
     #define NR_KSYMS 50
     /* Maxima logintud del nombre de un ksym */
     #define MAX_KSYM_NAME 128
   #endif

   #ifdef IDT_SUPPORT
     /* Numero maximo de interrupciones a proteger */
     #define NR_IDT 50
   #endif

   #ifdef SYSCALL_SUPPORT
     /* Numero de syscalls a proteger (mirar /usr/include/asm/unistd.h) */
     #define NR_SYSCALLS 225
   #endif
   (Configurar solo en caso de plataformas Linux x86 y que el usuario haya pedido soporte
    para KSyms, IDT y/o syscalls)

   /* Maximo numero de archivos que tendra la BBDD */
   #define MAXFILES 256
   (Con 256 creo que es mas que suficiente, pon mas o menos segun te convenga)

   /* Maximo numero de caracteres que tendra un archivo */
   /* NO PUEDE SER MENOR QUE 28 */
   #define MAX_NAME_SZ 256
   (No toques esto a no ser que sepas lo que haces y lo necesites)

   /* Buffer que usara para recibir y mandar ficheros */
   #define MAX_BUF 1024
   (Lo mismo que para el MAX_NAME_SZ)

   /* Longitud maxima del comando que se le mandara al servidor */
   #define MAX_CMD MAX_NAME_SZ+7
   (No cambiar)

   /* Configuralo con la ruta ABSOLUTA al dir locale del programa     */
   /* La ruta ha de ser absoluta ya que con la relativa hay problemas */
   /* cuando el programa no se ejecuta en el directorio nativo        */  
   #define LOCALE_DIR "/usr/local/share/locale/"
   (Pon la ruta absoluta adonde esten los .mo)

   /* Fichero para evitar que haya 2 ProSum's corriendo a la vez */
   /* en este ejemplo el fichero /var/run tendria que existir    */
   #define LOCK_FILE "/var/run/prosum.pid"

   /* Nombre que usara esta maquina en el bastion host para hacer el */
   /* directorio donde estaran sus archivos protegidos               */ 
   #define ALIAS_NAME "plastic"

   /* Longitud maxima del alias */
   #define MAX_ALIAS_SZ 25

   /* Puerto donde correra el servidor TCP en el Bastion Host */
   #define TCPSERV_PORT 1234
   (Puerto donde escuchara el servidor)

   /* Nombre del Bastion Host */
   #define TCPSERV_NAME "localhost"
   (Host de la maquina bastion, deberias cambiarlo)

   /* Segundos que se esperara para conectar al host bastion */
   #define TCPSERV_TIMEOUT 5
   (Tiempo que esperara el ProSum (en segundos) para conectar al host bastion)

   /* Tamao de la cola de espera para el servidor TCP */
   #define TCPSERV_BACKLOG 10

   #define SELF_PASSWD "aCFgkoA50J8Mg"
   (No cambiar, es el password del ProSum)

   #endif

   Una vez hechos los cambios deseados, guarda este archivo.

3. Compilando:
   Una vez configurado todo ya podemos compilar el programa usando GNU make:
   $ make
   ...
   gcc -c main.c -g -O2  -Iinclude -I. -DVERSION=\"<version>\" -DPACKAGE=\"ProSum\" -DIS_LINUX_X86
   gcc -o prosum include/md5.o include/md5_2.o include/stat.o include/main_if.o include/idt.o 
   include/syscall.o include/ksyms.o include/kmem.o main.o -g -O2  -lssl -lreadline
   -ltermcap  -lcrypto -lnsl
   gcc -c snd_tcp_serv.c -g -O2  -I../../include -I../.. -DVERSION=\"<version>\" -DPACKAGE=\"ProSum\" -DIS_LINUX_X86
   gcc -o snd_tcp_serv snd_tcp_serv.o -g -O2  -lssl -lreadline -ltermcap  -lcrypto -lnsl

   El Makefile por defecto usa make, si make no correponde con el GNU make, especificalo
   en el configure con --with-make.

4. Poniendo En Marcha:
   Ahora vamos a instalarlo:
   $ su
   Password:
   # gmake install
   /usr/bin/install -c -d /usr/local/etc
   /usr/bin/install -c -m 600 prosum.conf /usr/local/etc
   /usr/bin/install -c -d /usr/local/bin
   /usr/bin/install -c -m 755 prosum /usr/local/bin
   /usr/bin/install -c -d /usr/local/doc/ProSum-<version>
   /usr/bin/install -c -m 644 README.es README.en COPYING ChangeLog TODO AUTHORS 
   /usr/local/doc/ProSum-<version>
   /usr/bin/install -c -m 755 utils/snd_tcp_serv/snd_tcp_serv /usr/local/bin
   /usr/bin/install -c -d /usr/local/share/locale/es/LC_MESSAGES
   /usr/bin/install -c -m 644 locale/es/LC_MESSAGES/ProSum.mo 
   /usr/local/share/locale/es/LC_MESSAGES

   ProSum <version> Installed

   #

   Como podemos ver mete en /usr/local/bin el binario del programa: prosum, y el binario del
   servidor tcp: snd_tcp_serv. En /usr/local/doc/ProSum-<version> los ficheros de documentacion
   y en /usr/local/share/locale/es/ el fichero para la traduccion al espaol ProSum.mo. Y en
   /usr/local/etc/ mete el prosum.conf donde mas tarde definiremos los ksyms que protegeremos.

   NOTA: Estos directorios pueden cambiar o especificarse en el configure, para mas informacion 
   hacer ./configure --help.

   Una vez instalado el programa, hacer un strip /usr/local/bin/prosum para mayor seguridad.

   Para que nos salga en espaol...
   # export LC_ALL=es_ES
   #

   Ahora vamos a instalar en el host bastion el servidor ProSum, para hacer esto mandamos 
   el /usr/local/bin/snd_tcp_serv al host bastion.
   bastion# adduser prosum -d /home/prosum
   bastion# su - prosum
   bastion$
   y metemos el snd_tcp_serv en /home/prosum, y lo ejecutamos:
   bastion$ export LC_ALL=es_ES
   bastion$ ./snd_tcp_serv &
   [1] 27655
   bastion$

   En el syslogd podemos ver...
   ago 20 19:33:50 bastion Servidor ProSum: Servidor Iniciado, PID: 27655

   NOTA: Si el host bastion fuese de otra arquitectura o SO que donde se compilo el ProSum 
   habra que compilar el snd_tcp_serv en el bastion host.

   Una vez instalado vamos a hacer nuestra base de datos:
   Primero editar el /usr/local/etc/prosum.conf y ajustarlo que necesitemos.
   Una mal configuracion de este archivo podria hacer cascar el kernel entero, asi que estate
   seguro de que pones las direcciones adecuadas.

   Y ahora hacemos la base de datos:
   # echo "/bin/ping" > ficheros
   # prosum -c ficheros bbdd -f /usr/local/etc/prosum.conf -p PASSWORD

   Ajustando Locale A: es_ES

   #

   Guardamos la base de datos en un disket solo lectura o en algun sitio seguro, por si se
   queda mal o algun intruso la intenta modificar.

   NOTA: Si se quiere encriptar para mayor seguridad la base de datos, al hacer el -c
   especificariamos tambien la opcion -e <clave> -s <semilla>, obviamente si creamos la BBDD
   encriptada al hacer un -v habria que especificarle la opcion -d <clave> -s <semilla> para
   que la desencripte.

   Al mismo tiempo que se hace un prosum -c se mandan los archivos que se vayan a proteger
   al host bastion, con lo cual en el host bastion podemos ver en el syslogd...

   ago 20 19:46:27 bastion Servidor ProSum: Conexion Detectada Desde 192.168.0.2
   ago 20 19:46:27 bastion Servidor ProSum: Cliente Conectado Desde 192.168.0.2
   ago 20 19:46:27 bastion Servidor ProSum: Setup Del Alias plastic Recibido De 192.168.0.2
   ago 20 19:46:27 bastion Servidor ProSum: Conexion Detectada Desde 192.168.0.2
   ago 20 19:46:27 bastion Servidor ProSum: Cliente Conectado Desde 192.168.0.2
   ago 20 19:46:27 bastion Servidor ProSum: ping Recibido Desde 192.168.0.2

5. Ejecutando

   Ya tenemos protegido el fichero /bin/ping, la IDT, los ksyms que hayamos especificado y las
   syscalls que le hayamos especificado, vamos a verlo!...
   # prosum -r bbdd

   Ajustando Locale A: es_ES


   ***** Ficheros *****
   ------------- 1 --------------
   Archivo: /bin/ping
   Flags Extendidos: --------------
   UID: 0 (root)   GID: 0 (root)
   Size: 22620 Bytes
   Mtime: enero 16 - martes - 16:34:21 CET 2001
   md5sum: 6ed9539f98ad1f5966c3c2c7f3f45ff5
   Modo: rwsr-xr-x
   -----------------------------

   ***** KSYMS *****
   Nombre KSym: ip_rcv       Direccion: 0xc020f600
   Nombre KSym: memset       Direccion: 0xc0268ec0
   Nombre KSym: kmalloc      Direccion: 0xc01304e0

   ***** IDT *****
   Numero De Interrupcion: 0       Direccion: 0xc0106f60
   Segmento: KERNEL_CS     Banderas: 8F
   Numero De Interrupcion: 1       Direccion: 0xc0106ffc
   Segmento: KERNEL_CS     Banderas: 8F
   Numero De Interrupcion: 2       Direccion: 0xc0107008
   Segmento: KERNEL_CS     Banderas: 8E
   ... (Mas interrupciones) ...
   ***** Syscalls *****
   Syscall: sys_exit       Direccion: 0xc01189f0
   Syscall: sys_fork       Direccion: 0xc0105ac0
   Syscall: sys_read       Direccion: 0xc0138e00
   Syscall: sys_write      Direccion: 0xc0138ed0
   Syscall: sys_open       Direccion: 0xc0138940
   ... (Mas Syscalls) ...
   #

   Vamos a chequear lo que tenemos protegido:
   # prosum -v bbdd -f /usr/local/etc/prosum.conf

   Ajustando Locale A: es_ES


   ***** Ficheros *****
   -----------------------------
   Archivo: /bin/ping
   Sin Cambios

   **** KSYMS ****
   Chequeando ip_rcv KSym...
   Sin Cambios
   Chequeando memset KSym...
   Sin Cambios
   Chequeando kmalloc KSym...
   Sin Cambios

   ***** IDT *****
   Chequeando Interrupcion 0...
   Sin Cambios
   Chequeando Interrupcion 1...
   Sin Cambios
   Chequeando Interrupcion 2...
   Sin Cambios
   ... (Mas) ...

   ***** Syscalls *****
   Chequeando sys_exit (1)...
   Sin Cambios
   Chequeando sys_fork (2)...
   Sin Cambios
   ... (Mas) ...
   #

   Supongamos que un intruso ha pillado root y ha modificado el /bin/ping para que le de 
   shell de root cuando el quiera, pues cuando chequearamos con el ProSum veriamos...
   # prosum -v bbdd -f /usr/local/etc/prosum.conf

   Ajustando Locale A: es_ES


   ***** Ficheros *****
   -----------------------------
   Archivo: /bin/ping
   MD5 Ha Cambiado!! De: 3256e936790d483c780a42b432b4b37c A: 7aff93b19cb433e441fcf820627990d4

   El Tamao Ha Cambiado!! De: 2375 A: 2378

   La Fecha De Ultima Modificacion Ha Cambiado!! De: agosto 20 - martes - 19:13:55 CEST 2002 
   A: agosto 20 - martes - 19:21:51 CEST 2002

   ... (Mas) ...
   #

   NOTA: Nunca hacer un prosum -v bbdd | more, y en caso de hacerse dejar acabar al more.

   Vemos que ha cambiado el tamao, el md5sum, etc., asi que vamos a corregirlos:
   # prosum -v bbdd -a -f /usr/local/etc/prosum.conf

   Ajustando Locale A: es_ES


   ***** Ficheros *****
   -----------------------------
   Archivo: /bin/ping
   MD5 Ha Cambiado!! De: 72dfa592c708b3874cf17a5f829066e3 A: 7aff93b19cb433e441fcf820627990d4

   Size Has Changed!! From: 2373 To: 2378

   La Fecha De Ultima Modificacion Ha Cambiado!! De: agosto 20 - martes - 19:44:05 CEST 2002 
   A: agosto 20 - martes - 19:48:40 CEST 2002
   OK, Cambios Reemplazados
   ... (Mas) ...
   #

   En el syslogd del host bastion podemos ver...
   ago 20 19:49:56 plastic Servidor ProSum: Conexion Detectada Desde 127.0.0.1
   ago 20 19:49:56 plastic Servidor ProSum: Cliente Conectado Desde 127.0.0.1
   ago 20 19:49:56 plastic Servidor ProSum: ping Mandado A 127.0.0.1

   Miramos el /bin/ping... Y ya esta como antes!

   En caso de que hubiese cambiado el UID y/o el GID, el procedimiento seria exactamente 
   el mismo.

   Pongamos ahora que hemos instalado otra version mas nueva del ping y queremos quedarnos 
   con ella, pues guardamos los cambios en la BBDD y automaticamente se guardaran en el 
   host bastion...
   # prosum -v bbdd -i -f /usr/local/etc/prosum.conf -p PASSWORD

   Ajustando Locale A: es_ES


   ***** Ficheros *****
   -----------------------------
   Archivo: /bin/ping
   MD5 Ha Cambiado!! De: 6ed9539f98ad1f5966c3c2c7f3f45ff5 A: f4f1e0c210dbe5b808db4bf197db3bc8

   Size Has Changed!! From: 22620 To: 2379

   La Fecha De Ultima Modificacion Ha Cambiado!! De: agosto 20 - martes - 19:52:42 CEST 2002 
   A: agosto 20 - martes - 19:56:14 CEST 2002

   Si este/os cambio/s fue/ron intencionados responde Y


   Quieres Salvar El/Los Cambio/s? (Y/N): Y <enter>
   OK, Cambios Guardados

   ... (Mas) ...
   #

   Con las syscalls, los KSyms y la IDT el procedimiento es exactamente igual, excepto que no
   conecta al bastion host para nada.

   NOTA: La opcion -f solo hace falta especificarla si se ha compilado el ProSum con soporte
   para ksyms.

6. Automatizando:
   Obviamente no vamos a estar haciendo esto siempre a mano, con lo cual lo que haremos es 
   que en el bastion host meteremos en el /etc/rc.d/rc.local o equivalente lo siguiente:
   cd /home/prosum && ./snd_tcp_serv &

   Y en el crond del root de la maquina que corre el ProSum meteremos por ejemplo...
   echo -e "From: ProSum\r\nSubject: Verify Changes\r\n" > ret && \
   prosum -v bbdd -f /usr/local/etc/prosum.conf >> ret && \
   /var/qmail/bin/qmail-inject fkt < ret && rm -f ret

   Y asi si cambia algo lo veremos en el mail y ya tomaremos medidas.

   NOTA: Asi seria si usamos qmail, con otro MTA seria de otra forma.

7. Recomendaciones
   Las siguientes pautas a seguir son ALTAMENTE recomendables:
   - Guardar siempre una copia de la base de datos.
   - Poner la base de datos en un sitio solo lectura para comprobar los
     cambios, si se quieren salvar los cambios pues se pone para poder
     escribir un momento y punto.
   - Proteger el binario del ProSum, normalmente en /usr/local/bin/prosum
     con el propio ProSum, por si alguien lo cambia.
