/* config_prosum.h  -  ProSum configuration file
 *      Copyright (C) 2002 fkt <fkt@funfatal.org>
 *
 * This file is part of ProSum.
 *
 * ProSum is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ProSum is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _CONFIG_PROSUM_H
#define _CONFIG_PROSUM_H

#include "../config.h"

#ifdef KSYMS_SUPPORT
  /* Numero maximo de KSyms a proteger */
  #define NR_KSYMS 50
  /* Maxima logintud del nombre de un ksym */
  #define MAX_KSYM_NAME 128
#endif

#ifdef IDT_SUPPORT
  /* Numero maximo de interrupciones a proteger */
  #define NR_IDT 50
#endif

#ifdef SYSCALL_SUPPORT
  /* Numero de syscalls a proteger (mirar /usr/include/asm/unistd.h) */
  #define NR_SYSCALLS 225
#endif

/* Maximo numero de archivos que tendra la BBDD */
#define MAXFILES 256

/* Maximo numero de caracteres que tendra un archivo */
/* NO PUEDE SER MENOR QUE 28 */
#define MAX_NAME_SZ 256

/* Buffer que usara para recibir y mandar ficheros */
#define MAX_BUF 1024

/* Longitud maxima del comando que se le mandara al servidor */
#define MAX_CMD MAX_NAME_SZ+7

/* Configuralo con la ruta ABSOLUTA al dir locale del programa     */
/* La ruta ha de ser absoluta ya que con la relativa hay problemas */
/* cuando el programa no se ejecuta en el directorio nativo        */
#define LOCALE_DIR "/usr/local/share/locale/"

/* Fichero para evitar que haya 2 ProSum's corriendo a la vez */
/* en este ejemplo el fichero /var/run tendria que existir    */
#define LOCK_FILE "/var/run/prosum.pid"

/* Nombre que usara esta maquina en el bastion host para hacer el */
/* directorio donde estaran sus archivos protegidos               */
#define ALIAS_NAME "plastic"

/* Longitud maxima del alias */
#define MAX_ALIAS_SZ 25

/* Puerto donde correra el servidor TCP en el Bastion Host */
#define TCPSERV_PORT 1234

/* Nombre del Bastion Host */
#define TCPSERV_NAME "localhost"

/* Segundos que se esperara para conectar al host bastion */
#define TCPSERV_TIMEOUT 5

/* Tamao de la cola de espera para el servidor TCP */
#define TCPSERV_BACKLOG 10
