/* errors.h
 *      Copyright (C) 2002 fkt <fkt@funfatal.org>
 *
 * This file is part of ProSum.
 *
 * ProSum is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ProSum is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _ERRORS_H
#define _ERRORS_H

#include "common.h"

#if defined(SYSCALL_SUPPORT)
  #define ENOADDR 6   /* Ha cambiado la direccion de la syscall */
  #define ENOCODE 7   /* Ha cambiado el codigo de la rutina de la syscall */
  #define ENOSYSCALL 8  /* No se ha podido encontrar la direccion de la sys_call_table */
#endif

#define ENOVERSION 0  /* La version del servidor y el cliente de ProSum no coinciden o */
                      /*   el servidor no es ProSum */
#define ENOCMD 1      /* Comando Desconocido */
#define ENORECV 2     /* Error al recibir el fichero */
#define ENOSEND 3     /* Error al mandar el fichero */
#define ENODUPA 4     /* El alias ya existe */
#define ENOALIAS 5    /* El alias NO existe */

extern int value_err(int error);
//Evalua el error que no es standar de errno.h si no de errors.h, si el valor
//corresponde con uno definido en errors.h devuelve SUCCESS y si el error es
//standar de errno.h devuelve ERROR

#endif
