/* ext2.h
 *      Copyright (C) 2002 fkt <fkt@funfatal.org>
 *
 * This file is part of ProSum.
 *
 * ProSum is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ProSum is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _EXT2_H
#define _EXT2_H

#include <ext2fs/ext2_fs.h>
#include <asm/ioctl.h>
#include "common.h"

#undef EXT2_IOC_SETFLAGS
#undef EXT2_IOC_GETFLAGS

#define EXT2_IOC_GETFLAGS    _IOR('f', 1, sizeof(long))
#define EXT2_IOC_SETFLAGS    _IOW('f', 2, sizeof(long))

extern int do_ext2(file_t *f_st);
//rellena el campo f_st->ext2_flags

extern int check_ext2(file_t *f_st, file_t *f_cmp);
//compara el f_st->ext2_flags con f_cmp->ext2_flags

//Ambas funciones devuelven SUCCESS si ha ido bien, y en caso de fallo ERROR

extern void restore_ext2(char *filename, unsigned long flags);
//Restaura los flags en filename

extern void value_ext2(unsigned long flags, char *str);
//Evalua los flags

#endif
