/* ksyms.c  -  Kernel Symbols Manipulation
 *      Copyright (C) 2002 fkt <fkt@funfatal.org>
 *
 * This file is part of ProSum.
 *
 * ProSum is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ProSum is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include "ksyms.h"

int put_ksyms(char *conf, table_t *ksym_tbl) {
  size_t i=0, j;
  FILE *fd;
  int fd_kmem;
  char buf[256], *ptr, addr_tmp[8];

  if ((fd=fopen(conf,"rt"))==NULL) return ERROR;

  while (!feof(fd) && (i < NR_KSYMS)) {
    memset(buf,0x0,sizeof(buf));
    fgets(buf,248,fd);

    if (!strstr(buf,":") || (buf[0] == '#')) continue;

    for (ptr=buf, j=0; (*ptr != ':') && (j < MAX_KSYM_NAME) ; j++, ptr++)
      ksym_tbl->ksym_sta[i].ksym_name[j]=*ptr;

    ksym_tbl->ksym_sta[i].ksym_name[j]='\0';

    //Saltamos el ':'
    ptr++;

    for (j=0; (*ptr != '\0') && (j < 8) ; j++, ptr++)
      addr_tmp[j]=*ptr;

    addr_tmp[8]='\0';
    ksym_tbl->ksym_sta[i].addr=strtoul(addr_tmp,NULL,16);

    i++;
  }

  ksym_tbl->ksym_validos=i;

  fclose(fd);

  if ((fd_kmem=open("/dev/kmem", O_RDONLY))==-1) return ERROR;

  for (i=0 ; i < ksym_tbl->ksym_validos ; i++)
    readkmem(fd_kmem, ksym_tbl->ksym_sta[i].ksym_rutine, ksym_tbl->ksym_sta[i].addr, 7);

  close(fd_kmem);
  return SUCCESS;
}

int check_ksym(ksym_t *orig, ksym_t *cmp) {
  if (memcmp(orig->ksym_rutine,cmp->ksym_rutine,sizeof(orig->ksym_rutine)))
    return ERROR;

  return SUCCESS;
}

int restore_ksym(ksym_t *st) {
  int fd;

  if ((fd=open("/dev/kmem", O_RDWR))==-1) return ERROR;

  writekmem(fd, st->ksym_rutine, st->addr, 7);

  close(fd);
  return SUCCESS;
}
