/* main_if.h
 *      Copyright (C) 2002 fkt <fkt@funfatal.org>
 *
 * This file is part of ProSum.
 *
 * ProSum is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ProSum is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _MAIN_IF_H
#define _MAIN_IF_H

#include "common.h"

static unsigned int sec_init;
//Dice si esta o no inicializada la memoria segura

void init_secmem(void);
//Inicializa la memoria segura

extern int check_lock_file(char *file);
//Chequea si existe file, si existe devuelve ERROR y sino SUCCESS

extern int create_lock_file(char *lfile);
//Crea un fichero para evitar que haya 2 ProSum corriendo al mismo tiempo

extern int is_symbolic_link(char *file);
//Devuelve SUCCESS si file es un link simbolico o ERROR si no lo es

extern int file_srv(char *file, int cmd_opt);
//Manda o recibe el fichero file, en caso de fallo devuelve ERROR

extern void do_questions(int *replace, int *req_change, int changed,
                         int automatic, int interactive);
//Hace preguntas para saber que quiere hacer el usuario

extern void signal_handler(int signum);
//Rutina de tratamiento de signals

extern void clean_up(void);
//Limpia los ficheros temporales si los encuentra

extern int decrypt_bd(char *filename, CIPHER_HANDLE alg);
//Desencripta filename, el fichero desencriptado acaba en el propio filename

extern int encrypt_bd(char *filename, CIPHER_HANDLE alg);
//Encripta filename, el fichero encriptado acaba en el propio filename

extern void write_bd(FILE *fp_bd, table_t *f_tb);
//Escribe datos en la BBDD

extern void read_bd(FILE *fp_bd, table_t *f_tb);
//Recupera los datos de la BBDD

extern int copy_file(char *src, char *dst);
//Copia el fichero src en dst conservando el contenido de src. Si dst existe, lo machaca

extern void supr_retorno_carro(char *buf);
//Quita el retorno de carro de buf (si lo tiene)

extern void value_mode(mode_t mode, char *mode_str);
//Evalua y pone en mode_str los modos del archivo

extern void prosum_usage(char *prog);
//Muestra el uso del programa

#endif
