/* syscall.h
 *      Copyright (C) 2002 fkt <fkt@funfatal.org>
 *
 * This file is part of ProSum.
 *
 * ProSum is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ProSum is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _SYSCALL_H
#define _SYSCALL_H

#include "common.h"
#include "kmem.h"
#include <asm/unistd.h>

extern int put_syscalls(table_t *sc_tbl);
//Rellena la tabla con las syscalls y en caso satisfactorio devuelve SUCCESS o ERROR en caso de fallo

extern char *value_syscall(int id);
//Devuelve el nombre de la syscall segun el numero

extern int check_syscall(syscall_t *orig, syscall_t *cmp);
//Chequea la direccion de la Syscall, devuelve ENOADDR o ENOCODE en caso de fallo

extern int restore_syscall(syscall_t *st, int mode);
//Restaura la Syscall segun la estructura y el modo

#endif
